#
# spec file for package aria2 (Version 1.9.3)
#
# Copyright (c) 2010 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild

%if 0%{?_with_gnutls:1}
 %define with_gnutls 1
 %undefine with_openssl
%else
 %define with_openssl 1
 %undefine with_gnutls
%endif

%if 0%{?opensuse_bs}
%define with_dht 0
%else
%define with_dht 1
%endif
%if 0%{?suse_version} > 0 && 0%{?suse_version} >= 1020
%define with_sqlite 1
%else
%define with_sqlite 0
%endif

Name:           aria2
Version:        1.9.3
Release:        0.1.1
Summary:        Parallelizing Multi-Protocol Utility for Downloading Files
Source:         http://prdownloads.sourceforge.net/aria2/aria2-%{version}.tar.bz2
Patch1:         aria2-cares-static.patch
Patch2:         aria2-cares-lib64.patch
Patch4:         aria2-atoi.patch
Url:            http://sourceforge.net/projects/aria2
Group:          Productivity/Networking/Other
License:        GNU General Public License (GPL)
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
%if 0%{?suse_version:1}
%if %{?with_gnutls:1}0
BuildRequires:  libgcrypt-devel
%if %suse_version > 1030
BuildRequires:  libgnutls-devel
%else
BuildRequires:  gnutls-devel
%endif #%suse_version > 1030
%endif #with_gnutls
%if %{?with_openssl:1}0
%if %suse_version >= 1030
BuildRequires:  libopenssl-devel
%else
BuildRequires:  openssl-devel
%endif #%suse_version >= 1030
%endif #with_openssl
%if %suse_version >= 1030
BuildRequires:  libexpat-devel
%else
BuildRequires:  expat
%endif #expat
%else
%if %{?with_gnutls:1}0
BuildRequires:  expat
%endif #with_gnutls
%if %{?with_openssl:1}0
BuildRequires:  openssl-devel
%endif #with_openssl
BuildRequires:  expat-devel
%endif #0%{?suse_version:1}
%if 0%{?!suse_version:1} || 0%{?suse_version} >= 1020
BuildRequires:  cppunit-devel
%endif
BuildRequires:  gettext gettext-devel intltool
BuildRequires:  gcc-c++ glibc-devel libstdc++-devel make
%if 0%{?suse_version} >= 1130
BuildRequires:  libcares-devel
%endif #cares
%if 0%{?with_sqlite}
%if 0%{?suse_version} < 1100
BuildRequires:  sqlite-devel
%else
BuildRequires:  sqlite3-devel
%endif #suse_version
%endif #with_sqlite
BuildRequires:  autoconf automake libtool
Provides:       aria2c = %{version}-%{release}

%description
aria2 is a utility for downloading files. It has completely new design
concept from its predecessor, Aria, and is written from scratch. aria2 has
a segmented downloading engine in its core. It can download one file from
multiple URLs or multiple connections from one URL. This results in very
high speed downloading, much faster than ordinary browsers. This engine in
was implemented in a single-thread model. The architecture is clean and easy
to extend.

aria2 currently supports HTTP, FTP, and BitTorrent.




Authors:
--------
    Tatsuhiro Tsujikawa <tujikawa@users.sourceforge.net>

%prep
%setup -q -n "aria2-%{version}"
%if 0%{?with_cares}
%patch1
%if "%{_lib}"=="lib64"
%patch2
%endif #%_lib==lib64
%endif #cares
%patch4

%build
export CFLAGS="%{optflags} -DPIC -fPIC"
export CXXFLAGS="${CFLAGS}"
%configure \
	--with%{?!with_gnutls:out}-gnutls \
	--with%{?!with_openssl:out}-openssl \
	--with%{?!with_cares:out}-libcares \
	--without-libxml2 \
%if 0%{?with_sqlite}
    --with-sqlite3 \
%else
    --without-sqlite3 \
%endif
    --enable-epoll \
	--enable-bittorrent \
    --with-openssl-prefix="%{_usr}" \
    --with-libgnutls-prefix="%{_usr}" \
    --with-libgcrypt-prefix="%{_usr}" \
    --with-libz-prefix="%{_usr}" \
    --with-xml-prefix="%{_usr}" \
    --with-sqlite3-prefix="%{_usr}"
# a buglet in the configure script causes this directive to cause the opposite, so comment it out
# poeml, Mon Aug  4 16:30:55 CEST 2008
	#--enable-metalink
#echo '#define HAVE_LIBGEN_H 1' >> config.h
#%__rm src/libgen.h
%__make %{?jobs:-j%{jobs}}

%install
%makeinstall
%__rm -rf "%{buildroot}%{_datadir}/doc"
for l in "en@boldquot" "en@quot"; do
    %__rm -rf "%{buildroot}%{_datadir}/locale/${l}"
done
%if 0%{?suse_version}
%find_lang aria2
%else
# for some reason, find_lang fails to find anything and
# breaks the build on Fedora 9
echo -n > aria2.lang
%endif

#check
#__make check

%clean
%__rm -rf "%{buildroot}"

%files -f "aria2.lang"
%defattr(-,root,root)
%doc AUTHORS ChangeLog COPYING NEWS README
%doc README.html
%doc doc/aria2c.1.html
%{_bindir}/aria2c
%doc %{_mandir}/man1/aria2c.1%{ext_man}

%changelog
* Sat May 22 2010 pascal.bleser@opensuse.org
- update to 1.9.3 to fix bnc#605937, CVE-2010-1512: Directory
  traversal vulnerability in aria2 before 1.9.3 allows remote
  attackers to create arbitrary files via directory traversal
  sequences in the name attribute of a file element in a metalink
  file.
- upstream changelog of 1.9.3:
  * fixes the bug in which aria2 cuts a filename after a ";"
    character if the filename in the Content-Disposition header
    includes a ";" character
  * fixes the bug in which the name attribute of the file element
    in a Metalink file is not properly sanitized
* Tue Feb  9 2010 pascal.bleser@opensuse.org
- removed obsolete patch aria2-1.5.2-CVE-2009-3617.diff (merged
  upstream)
- update to 1.8.2 to fix bnc#556299
* Mon Nov  2 2009 lnussel@suse.de
- fix format string problem (bnc#547318, CVE-2009-3617)
* Sat Aug 22 2009 poeml@suse.de
- update to 1.5.2:
  This release fixes the bug that when the first attempt to establishing
  connection fails, aria2 don't try to connect another address and a
  download immediately fails.  -S output was enhanced: exact file size
  is now printed. For -S with torrent file, meta data such as comment,
  comment.utf-8, created by and creation date are now printed. Ukrainian
  and Russian translations were updated.
  See also http://bugzilla.novell.com/show_bug.cgi?id=532575.
* Mon Aug 17 2009 poeml@suse.de
- remove obsolete patch aria2-large_ftp.patch
* Sun Jul 26 2009 pascal.bleser@opensuse.org
- update to 1.5.1:
  * fixes a linker error in unit test code on 32-bit systems
  * file I/O error handling was written
* Sat Jul 18 2009 pascal.bleser@opensuse.org
- update to 1.5.0:
  * adds Web seeding support for multi-file torrents
  * a --bt-stop-timeout option was added
  * aria2 now tries all resolved addresses to connect to remote HTTP(S)/FTP servers until it is connected
  * for XML-RPC, two new methods were added: aria2.tellWaiting and aria2.getVersion
  * --use-head is now disabled by default since the HEAD request causes problems with some Web sites
  * the Russian, Italian, Danish, Bulgarian, Japanese, and Ukrainian translations were updated
* Thu Jun 25 2009 poeml@suse.de
- remove --without-libares from the configure options, which isn't
  recognized (anymore). There's --without-libcares, instead, which
  is already in use.
* Sun Jun  7 2009 pascal.bleser@opensuse.org
- update to 1.4.1:
  * the aria2.tellStatus XML-RPC method now returns "uploadLength" and "numSeeders"
  * the Ukrainian translation was updated
* Sun May 31 2009 pascal.bleser@opensuse.org
- update to 1.4.0:
  * adds an XML-RPC interface: the current XML-RPC API allows users to add HTTP(S)/FTP/torrent/Metalink download and change options dynamically: the APIs such as reporting download progress, file paths, URIs, and peer information are also available
  * adds the ability to run a command when a download is started/stopped
  * adds the ability to save cookies
  * the console readout was slightly updated and now includes the number of seeders the client has connected to
  * a Slovak translation was added
  * ukrainian and Brazilian Portuguese translation were updated
* Fri May  8 2009 pascal.bleser@opensuse.org
- update to 1.3.3:
  * fixes the bug in which the --check-integrity option doesn't
    work properly if a file including the last piece is missing
  * the internal receive buffer was increased for FTP in order to
    receive big banners
  * the Ukrainian, Russian, and Simplified Chinese translations
    were updated
* Thu Apr 30 2009 pascal.bleser@opensuse.org
- added patch by Rudi Oertel to avoid crashes with FTP banner sizes
  larget than 4kb (now handles 64kb), sent upstream:
  https://sourceforge.net/tracker/?func=detail&aid=2784659&group_id=159897&atid=813675
* Tue Apr 28 2009 pascal.bleser@opensuse.org
- update to 1.3.2:
  * fixes the bug that prevents certain BitTorrent downloads from
    finishing
  * fixes a possible segmentation fault when gzip decoding is
    involved
  * fixes an infinite loop bug if the last "0" chunk-size marker is
    not received in chunked encoding transfer
  * aria2 now supports Web seeding (HTTP seeding) for a single file
    torrent
  * the Ukrainian translation was updated
* Mon Apr 13 2009 pascal.bleser@opensuse.org
- update to 1.3.1:
  * fixes a bug where aria2 incorrectly determined that the
    specified share ratio was reached because of miscalculation of
    upload bytes
  * fixes a bug where the upload limit exceeded the value specified
    in the --seed-ratio option depending on the timing of the
    execution of SeedCheckCommand
* Wed Apr  1 2009 pascal.bleser@opensuse.org
- update to 1.3.0:
  * performance optimizations
  * adds the ability to specify the output filenames in BitTorrent
    downloads
  * adds the option to limit overall download speed
  * adds a dry run mode
  * adds the file allocation mode 'falloc'
  * the -i list option can now take new options: select-file and
    index-out
  * the default behavior of sending HTTP Authorization header is
    reverted back to version 1.1.2 style
  * you can now seed read-only files in BitTorrent
  * Indonesian, Russian, Italian, Ukrainian, Simplified Chinese,
    Japanese, Spanish, and Norwegian Nynorsk translations were
    updated
* Fri Mar  6 2009 poeml@suse.de
- add patch for failing download when the adaptive URI selector is
  used (https://sourceforge.net/support/tracker.php?aid=2666026)
* Mon Feb 16 2009 poeml@suse.de
- update to 1.2.0 release
  The list of changes is mainly as given below, plus bugfixes.
* Wed Feb 11 2009 poeml@suse.de
- update to beta release 1.2.0b+20090210:
  This release adds the AdaptiveURISelector from Mandriva developers and
  changes the default value of --proxy-method option from 'tunnel' to
  'get'. The several BitTorrent options were added: limiting the number
  of peers, choosing port randomly from specified range, a toggle to
  seed after successful hash check and specifying IP address to report
  to a tracker. Hash checking is now done sequentially rather than
  simultaneously.  HTTP Authorization was also refined so that now
  authorization header is sent to the server only when it is
  requested(there are some exceptions, see Changes below). aria2 now
  returns exit code depending on the last error. All exit codes are
  documented in man page.  This release also adds experimental built-in
  HTTP server which provides the current download progress in plain
  html.
* Mon Dec 29 2008 pascal.bleser@opensuse.org
- update to 1.1.2:
  + fixes a bug where BitTorrent download didn't finish when a
    REJECT message was received before a CHOKE message
  + the --use-head option was added to toggle whether the HEAD
    method should be used in the first HTTP request
  + to use GET method as the first request, give --use-head=false
    to aria2c
- changes from 1.1.1:
  + fixes the bug where --summary-interval=0 didn't work
* Tue Dec 23 2008 pascal.bleser@opensuse.org
- update to 1.1.0:
  + fixes many bugs such as a buggy HTTP pipelining implementation
    that leads to corrupted downloads, bad cookie handling, and
    sending of badly formed URIs to the tracker
  + the --max-overall-upload-limit option was added to control
    overall (not per torrent) upload speed
  + the gettext package name was changed from "aria2c" to "aria2":
    this changes the installation directory of the documents and
    the translation files (*.mo)
* Tue Nov 25 2008 pascal.bleser@opensuse.org
- update to 1.0.1:
  + fixes a bug that caused floating point exceptions when the -T
  option is used without URIs
  + now using The HEAD method to get size information from a Web
  server
  + Ukrainian and Norwegian Nynorsk translations were updated
* Tue Nov 18 2008 pascal.bleser@opensuse.org
- update to 1.0.0:
  + adds the ability to verify peers using given trusted CA
  certificates and client certificate authentication in HTTPS
  + adds the ability to form a persistent connection using a proxy
  and support for well-known environment variables for proxy
  settings were also added
  + fixes the bug that caused a segmentation fault during seeding
  + now users can specify output the filename and directory in the
  input file
  + the average download speed are now printed in Download results
  + the following options are now enabled by default: --ftp-pasv and
  - -enable-direct-io
* Sun Oct 19 2008 pascal.bleser@opensuse.org
- update to 0.16.2:
  + fixes the bug that caused aria2 to abort when it receives a
  BitTorrent request message that requests data larger than 16KiB
  + Serbian translation was added
  + Ukrainian translation was updated
* Wed Oct 15 2008 poeml@suse.de
- Pascal's changes reviewed by me as required by Factory policy.
* Tue Oct 14 2008 pascal.bleser@opensuse.org
- update to 0.16.1:
  + adds a --dht-file-path option to change the dht.dat file
  + adds an --auto-save-interval option to change the interval for
    saving a control file (*.aria2)
  + fixes the bug where the last byte in a URL was not encoded
  + Ukrainian, Vietnamese, and Traditional Chinese translations
    were added
* Mon Oct 13 2008 poeml@suse.de
- Pascal's changes reviewed by me as required by Factory policy.
* Mon Oct  6 2008 pascal.bleser@opensuse.org
- update to 0.16:
  + add Firefox3 Cookie support
  + add ability to select the fastest server(URI) using the
    download speed observed in the previous downloads
  + add ability to get a timestamp from a remote server and apply
    it to a local file
  + add an option to specify the connect timeout
  + now uses netrc for HTTP
* Sat Sep  6 2008 pascal.bleser@opensuse.org
- update to 0.15.3:
  + fixed chunk checksum validation cannot detect trailing garbage
    data; BUG#2074141
  + made files whose name ends with ".gz", ".tgz" not inflated by
    Content Encoding Decoder
  + fixed infinite loop bug in FTP when SIZE command failed
  + contact tracker frequently when the number of connections are
    0 and is not finished yet
  + added -lrt to LIBCARES_LIBS if -lrt is needed to link program
    with -lcares
  + if an error occurred with a URI, remove identical URI from
    remaining URI list
  + added Turkish translation
  + updated German and Russian translations
- dropped patch8 gzip_in_metalink.patch, merged upstream
* Mon Sep  1 2008 poeml@suse.de
- add patch r679(stable-0.15 branch)
  fixes segmentation fault when Metalink file contains gzipped
  file and its filesize is provided.
* Fri Aug 15 2008 pascal.bleser@opensuse.org
- update to 0.15.2:
  + fixed memory leak
  + removed max chunk size check:
    http://sourceforge.net/tracker/index.php?func=detail&aid=2040169&group_id=159897&atid=813673
  + fixed unmatched malloc/free
  + now aria2 uses name attribute in Metalink as local filename
    in BitTorrent downloads:
    http://sourceforge.net/tracker/index.php?func=detail&aid=2033999&group_id=159897&atid=813673
  + fixed occasional assertion failure in PieceSegment
  + fixed man page: --follow-bittorrent should be --follow-torrent
  + added Danish and Greek translations
  + updated Catalan, Norwegian Nynorsk and Spanish translations
* Fri Aug 15 2008 poeml@suse.de
- remove hardcoded %%debug_package
- expand tabs in spec file header
- indent some macros at the top which break the internal
  check_if_valid_source_dir tool
* Fri Aug 15 2008 poeml@suse.de
- initial submission to openSUSE Factory.
  Previous changelog:
  | * Mon Aug  4 2008 Peter Poeml <poeml@suse.de> 0.15.1+1
  | - new upstream version 0.15.1+1:
  |   * Fixed the bug that causes segmentaion fault when resuming download
  |     using metalink without size tag. Reproducible only using HTTP URI.
  | - a buglet in the configure script causes this directive to cause the
  |   opposite, so comment out the "--enable-metalink"
  | * Thu Jul 31 2008 Pascal Bleser <guru@unixtech.be> 0.15.1
  | - new upstream version:
  |   * fixes broken gzip inflation
  |   * lowers CPU usage
  |   * other minor fixes
  |   * Bulgarian and French translations were updated
  | * Wed Jul 23 2008 Pascal Bleser <guru@unixtech.be> 0.15.0
  | - new upstream version:
  |   * adds HTTP gzip content encoding support
  |   * adds the ability to save a signature in Metalink as a file
  |   * adds the option to skip hash checking in BitTorrent seeding
  |   * adds support for FTP servers that don't support the SIZE/REST command
  |   * a Bulgarian translation was added
  | * Sat Jun 21 2008 Pascal Bleser <guru@unixtech.be> 0.14.0
  | - new upstream version:
  |   * adds epoll support for Linux
  |   * adds the ability to limit the number of files to be opened to support more than 1024 files in a multi-file torrent
  |   * several bugs in BitTorrent downloads are fixed
  |   * from this release, aria2 downloads a file using 5 connections in HTTP/FTP by default, and the behavior of the -s option has changed
  | * Sun May 25 2008 Pascal Bleser <guru@unixtech.be> 0.13.2
  | - new upstream version:
  |   * adds the ability to specify any number of URIs, torrents, and metalinks in a command-line
  |   * adds option to set user-defined HTTP headers
  |   * adds support for transparent Metalink and connection reuse for HTTP/FTP downloads
  |   * adds output at given interval of a download progress summary
  |   * adds option to suppress any console output
  | * Tue May 20 2008 Pascal Bleser <guru@unixtech.be> 0.13.1+2
  | - new upstream version
  | * Mon Apr 28 2008 Pascal Bleser <guru@unixtech.be> 0.13.1
  | - bumped up in-tree libxml2 to 2.6.32
  | * Sat Mar 15 2008 Pascal Bleser <guru@unixtech.be> 0.13.1
  | - new upstream version
  | * Sat Mar  1 2008 Pascal Bleser <guru@unixtech.be> 0.13.0
  | - new upstream version
  | * Fri Feb 15 2008 Pascal Bleser <guru@unixtech.be> 0.12.1+1
  | - new upstream version
  | * Tue Feb 12 2008 Pascal Bleser <guru@unixtech.be> 0.12.1
  | - bumped intree libxml2 to latest 2.6.31
  | - new upstream version
  | * Sun Dec 30 2007 Pascal Bleser <guru@unixtech.be> 0.12.0
  | - fixed build on Factory
  | * Sun Dec  9 2007 Pascal Bleser <guru@unixtech.be> 0.12.0
  | - new upstream version
  | * Sat Nov 17 2007 Pascal Bleser <guru@unixtech.be> 0.11.5
  | - new upstream version
  | * Sun Oct 28 2007 Pascal Bleser <guru@unixtech.be> 0.11.4
  | - don't use intree libxml2 on openSUSE 10.3, as 10.3 ships a sufficiently recent libxml2-2.6.30
  | - new upstream version
  | * Mon Sep 10 2007 Pascal Bleser <guru@unixtech.be> 0.11.3
  | - new upstream version
  | * Sat Sep  8 2007 Pascal Bleser <guru@unixtech.be> 0.11.2
  | - moved to openSUSE Build Service
  | * Fri Aug 24 2007 Pascal Bleser <guru@unixtech.be> 0.11.2-2
  | - built against c-ares 1.4.0
  | - bumped in-tree libxml2 to 2.6.30
  | * Thu Aug  9 2007 Pascal Bleser <guru@unixtech.be> 0.11.2-1
  | - bumped in-tree libxml2 to 2.6.29
  | - new upstream version
  | * Tue Jun 12 2007 Pascal Bleser <guru@unixtech.be> 0.11.0-1
  | - new upstream version
  | * Fri Apr 27 2007 Pascal Bleser <guru@unixtech.be> 0.10.2.1-1
  | - new upstream version
  | * Wed Apr 18 2007 Pascal Bleser <guru@unixtech.be> 0.10.2-2
  | - update in-tree libxml2 version to 2.6.28
  | * Wed Mar 28 2007 Pascal Bleser <guru@unixtech.be> 0.10.2-1
  | - new upstream version
  | - CHANGES: adds netrc support
  | - CHANGES: adds user configuration file support
  | - CHANGES: adds the ability to change user-agent
  | - CHANGES: adds the ability to resume downloading a partially downloaded file by other programs that download files sequentially from the beginning
  | - CHANGES: numerous improvements and bugfixes have also been made
  | * Wed Feb  7 2007 Pascal Bleser <guru@unixtech.be> 0.10.1-1
  | - new upstream version
  | * Fri Feb  2 2007 Pascal Bleser <guru@unixtech.be> 0.10.0.1-1
  | - new upstream version
  | * Sun Jan 28 2007 Pascal Bleser <guru@unixtech.be> 0.10.0-1
  | - bundle libxml2 on SUSE < 10.0 to avoid forcing an upgrade that breaks stuff
  | - new upstream version
  | * Thu Dec  7 2006 Pascal Bleser <guru@unixtech.be> 0.9.0-2
  | - statically link libcares
  | * Wed Nov  8 2006 Pascal Bleser <guru@unixtech.be> 0.9.0-1
  | - new upstream version
  | * Sun Oct  1 2006 Pascal Bleser <guru@unixtech.be> 0.8.1-1
  | - new upstream version
  | * Sun Sep 24 2006 Pascal Bleser <guru@unixtech.be> 0.8.0-1
  | - new upstream version
  | * Tue Aug 29 2006 Pascal Bleser <guru@unixtech.be> 0.7.3-1
  | - added missing buildrequires for libgcrypt-devel
  | - new upstream version
  | * Mon Aug 21 2006 Pascal Bleser <guru@unixtech.be> 0.7.2-1
  | - new upstream version
  | * Mon Aug 14 2006 Pascal Bleser <guru@unixtech.be> 0.7.1-1
  | - add buildrequiers for c-ares[-devel] to support async DNS
  | - new upstream version
  | * Tue Aug  8 2006 Pascal Bleser <guru@unixtech.be> 0.7.0-1
  | - new upstream version
  | * Fri Jul 21 2006 Pascal Bleser <guru@unixtech.be> 0.6.0-1
  | - new upstream version
  | * Sun Jun 25 2006 Pascal Bleser <guru@unixtech.be> 0.5.2-1
  | - new upstream version
  | * Sun Jun 18 2006 Pascal Bleser <guru@unixtech.be> 0.5.1-1
  | - dropped patch, has been sent and merged upstream
  | - new upstream version
  | * Fri May 26 2006 Pascal Bleser <guru@unixtech.be> 0.5.0-1
  | - new upstream version
  | * Sun Apr 30 2006 Pascal Bleser <guru@unixtech.be> 0.4.1-1
  | - moved autoreconf and configure to build section
  | - new upstream version
  | * Fri Apr 21 2006 Pascal Bleser <guru@unixtech.be> 0.4.0-1
  | - added binary stripping for SUSE < 9.3
  | - new upstream version
  | - removed Distribution and Packager, injected by rpmmacros
  | * Sat Apr  1 2006 Pascal Bleser <guru@unixtech.be> 0.3.2-1
  | - added gnutls support, used by default, rebuild with --with openssl to use openssl instead
  | - new upstream version
  | * Fri Mar 24 2006 Pascal Bleser <guru@unixtech.be> 0.3.1-1
  | - new package
